
           /*     CliIODevice.jav      */

import java.awt.*;
import java.awt.event.*;
import java.awt.Graphics;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;


public class CliIODevice extends JFrame implements ActionListener {
    public CliIODevice() {

       super("Client");
       Container contentPane=(JPanel)getContentPane();
	   contentPane.setLayout(new BorderLayout());
	   contentPane.setBackground(Color.blue);
	                                                   
													   

       border3 = BorderFactory.createCompoundBorder(titledBorder2,
	                 BorderFactory.createEmptyBorder(5,5,5,5));
    
	   contentPane.setLayout(borderLayout1);												   
													   										   										   
										
									
													     //Pannello richiesta
       reqPan = new JPanel();
       reqPan.setBackground(Color.lightGray);
	   reqPan.setBorder(border3);
       reqButton = new JButton("RICHIESTA");
       reqButton.addActionListener(this);
       aggButton = new JButton("LOGIN");
       aggButton.addActionListener(this);
	  
       JLabel labSel = new JLabel("SELEZIONE",JLabel.RIGHT);
       labSel.setForeground(Color.white);
       JLabel labDay = new JLabel("Giorno",JLabel.RIGHT);
       JLabel labFascia = new JLabel("Fascia",JLabel.RIGHT);

       selDay = new JComboBox();
       selDay.setBounds(new Rectangle(431, 169, 113, 16));
       selDay.setEditable(false);
       selDay.addItem("LUNEDI");
       selDay.addItem("MARTEDI");
       selDay.addItem("MERCOLEDI");
       selDay.addItem("GIOVEDI");
       selDay.addItem("VENERDI");
       selDay.addItem("SABATO");
       selDay.addItem("DOMENICA");
       selDay.addActionListener(this);

       selFascia = new JComboBox();
       selFascia.setBounds(new Rectangle(431, 169, 113, 16));
       selFascia.setEditable(false);
       selFascia.addItem("MATTINA");
       selFascia.addItem("POMERIGGIO");
       selFascia.addItem("SERA");
       selFascia.addItem("NOTTE");
       selFascia.addActionListener(this);

       GridBagConstraints limiti = new GridBagConstraints();
       GridBagLayout gbl = new GridBagLayout();
       reqPan.setLayout(gbl);
                                              //Pannello informazioni

       info = new JTextArea();
       info.setEditable(false);
       scrollPane = new JScrollPane(info);
       scrollPane.setAutoscrolls(true);
                                             //Pannello dati Server
       JLabel labServer = new JLabel("Server1", JLabel.RIGHT);
       labServer.setForeground(Color.white);
       JLabel labPort = new JLabel("     Porta1", JLabel.RIGHT);
       labPort.setForeground(Color.white);
       JLabel labServer2 = new JLabel("Server2", JLabel.RIGHT);
       labServer2.setForeground(Color.white);
       JLabel labPort2 = new JLabel("     Porta2", JLabel.RIGHT);
       labPort2.setForeground(Color.white);
       msgServer1 = new JTextField("localhost",7);
       msgPort1 = new JTextField("4321",4);
       msgServer2 = new JTextField("localhost",7);
       msgPort2 = new JTextField("4320",4);

                                              //Pannello Griglia Settimana
       JLabel labFasc1 = new JLabel("MATTINA",JLabel.LEFT);
       JLabel labFasc2 = new JLabel("POMERIGGIO",JLabel.LEFT);
       JLabel labFasc3 = new JLabel("SERA",JLabel.LEFT);
       JLabel labFasc4 = new JLabel("NOTTE",JLabel.LEFT);
       JLabel labGiorni = new JLabel("LUN    MAR    MER    GIO    VEN    SAB    DOM", JLabel.LEFT);
       labGiorni.setForeground(Color.lightGray);
       labFasc1.setForeground(Color.lightGray);
       labFasc2.setForeground(Color.lightGray);
       labFasc3.setForeground(Color.lightGray);
       labFasc4.setForeground(Color.lightGray);

       imgSettimana = new Griglia();
       imgSettimana.setBackground(new Color(200,200,200));
       imgSettimana.setSize(90,90);


       buildConstraints(limiti,0,0,1,1,0,0);
       limiti.anchor=GridBagConstraints.EAST;
       gbl.setConstraints(labServer,limiti);
       reqPan.add(labServer);

       buildConstraints(limiti,1,0,2,1,0,0);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       gbl.setConstraints(msgServer1,limiti);
       reqPan.add(msgServer1);

       buildConstraints(limiti,3,0,1,1,0,0);
       gbl.setConstraints(labPort,limiti);
       reqPan.add(labPort);
 
       buildConstraints(limiti,4,0,2,1,0,0);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       gbl.setConstraints(msgPort1,limiti);
       reqPan.add(msgPort1);

       buildConstraints(limiti,0,1,1,1,0,0);
       limiti.anchor=GridBagConstraints.EAST;
       gbl.setConstraints(labServer2,limiti);
       reqPan.add(labServer2);

       buildConstraints(limiti,1,1,2,1,5,5);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       gbl.setConstraints(msgServer2,limiti);
       reqPan.add(msgServer2);

       buildConstraints(limiti,3,1,1,1,0,0);
       gbl.setConstraints(labPort2,limiti);
       reqPan.add(labPort2);

       buildConstraints(limiti,4,1,2,1,5,5);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       gbl.setConstraints(msgPort2,limiti);
       reqPan.add(msgPort2);

       buildConstraints(limiti,1,2,5,1,20,0);
       limiti.anchor=GridBagConstraints.NORTH;
       gbl.setConstraints(aggButton,limiti);
       reqPan.add(aggButton);

       buildConstraints(limiti,1,3,3,1,13,0);
       limiti.anchor=GridBagConstraints.SOUTH;
       gbl.setConstraints(labGiorni,limiti);
       reqPan.add(labGiorni);

       buildConstraints(limiti,4,3,2,1,30,10);
       gbl.setConstraints(labSel,limiti);
       reqPan.add(labSel);

       buildConstraints(limiti,0,4,1,1,0,0);
       limiti.anchor=GridBagConstraints.EAST;
       gbl.setConstraints(labFasc1,limiti);
       reqPan.add(labFasc1);

       buildConstraints(limiti,1,4,3,4,0,3);
       limiti.anchor=GridBagConstraints.EAST;
       gbl.setConstraints(imgSettimana,limiti);
       reqPan.add(imgSettimana);

       buildConstraints(limiti,4,4,1,1,8,0);
       limiti.anchor=GridBagConstraints.EAST;
       gbl.setConstraints(labDay,limiti);
       reqPan.add(labDay);

       buildConstraints(limiti,5,4,1,1,0,0);
       gbl.setConstraints(selDay,limiti);
       reqPan.add(selDay);

       buildConstraints(limiti,0,5,1,1,0,3);
       gbl.setConstraints(labFasc2,limiti);
       reqPan.add(labFasc2);

       buildConstraints(limiti,4,5,1,1,0,0);
       gbl.setConstraints(labFascia,limiti);
       reqPan.add(labFascia);

       buildConstraints(limiti,5,5,1,1,0,0);
       gbl.setConstraints(selFascia,limiti);
       reqPan.add(selFascia);

       buildConstraints(limiti,0,6,1,1,0,0);
       gbl.setConstraints(labFasc3,limiti);
       reqPan.add(labFasc3);

       buildConstraints(limiti,0,7,1,1,0,0);
       gbl.setConstraints(labFasc4,limiti);
       reqPan.add(labFasc4);

       buildConstraints(limiti,5,7,1,1,0,0);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       gbl.setConstraints(reqButton,limiti);
       reqPan.add(reqButton);

       buildConstraints(limiti,0,8,6,2,30,20);
       limiti.fill=GridBagConstraints.BOTH;
       gbl.setConstraints(scrollPane,limiti);
       reqPan.add(scrollPane);

       reqPan.setBackground(new Color(62, 97, 68));

       contentPane.add(reqPan);

       //configurazione
       info.setText("Effettuare LOGIN dopo aver controllato le informazioni sui server.\n");
       reqButton.setEnabled(false);
       //eventuale recovery
       File lastReq = new File("LastReq.sav");            
       if (lastReq.exists()) {
         reqInCorso=true;
         info.append("Il servizio  ora disponibile\n");
         info.append("Inizio recovery\n"); 
         client.recovery();
       }

     }

    public void visualizzaFinPass(){
         finestraPassword= new finPass(this);
         reqInCorso=false;
         finestraPassword.setSize(300, 120);
         do{
             finestraPassword.show();
         }while(utente.getUser()==null);  
         this.setTitle("Client: "+ utente.getUser());
    }
	
	public void abilitaUtente(){
	  reqButton.setEnabled(true);
	}
	
	public void disabilitaUtente(){
	  reqButton.setEnabled(false);
	}
	
	
	public void actionPerformed(ActionEvent e) {
       Object source=e.getSource();
	   
       if (!reqInCorso){
	   	  if(source==aggButton){
		  	reqInCorso=true;
			visualizzaFinPass();
		    client.verificaUtente();
			client.aggiornaDb();
		  }
		  else if(source==reqButton){
            reqInCorso=true;
            String giorno=(String)selDay.getSelectedItem();
            String fascia=(String)selFascia.getSelectedItem();
            selCorrente = new Selezione(giorno, fascia);
            if (libero(giorno, fascia)){
              salvaInvio(giorno,fascia);
              info.append("Sta per essere inoltrata la richiesta per il giorno "+giorno +" nella fascia " +fascia +"\n");
              client.prenota();
            }
            else {
               reqInCorso=false;
               info.append("La sala prove non  disponibile "+ giorno +" di " +fascia+"\n");
            }			 
          }
    	}
       else{
         info.append("ATTENDERE PREGO:  in corso un'operazione\n");
       }
    }

	
	public static void main(String[] args) {
        final JFrame frame;
				try {
            UIManager.setLookAndFeel(
                UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            System.err.println("Impossibile utilizzare lo stile "
                             + "di sistema: " + e);
        }

        frame = new CliIODevice();

        WindowListener l = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
              frame.setVisible(false);
							frame.dispose();
            	System.exit(0);
            }
  			};
        frame.addWindowListener(l);
        frame.setSize(495,375);
				frame.setResizable(false);
				frame.setVisible(true);
			
			
		
	}
	
		public void setUtente(Utente utente){
			this.utente=utente;
		
		}
		
		public Utente getUtente(){
			return this.utente;
		}

    private void salvaInvio(String giorno, String fascia){
         try{
            info.setText("Salvata copia della richiesta su disco.\n");
            FileOutputStream fos = new FileOutputStream("LastReq.sav");
            BufferedOutputStream bos = new BufferedOutputStream(fos);
            DataOutputStream dos = new DataOutputStream(bos);
			dos.writeUTF(msgServer1.getText());
			dos.writeInt(Integer.parseInt((msgPort1.getText()).trim()));
			dos.writeUTF(msgServer2.getText());
			dos.writeInt(Integer.parseInt((msgPort2.getText()).trim()));
            dos.writeUTF(utente.getUser());
            dos.writeUTF(utente.getPassword());           //password in chiaro su disco!!!!!
            dos.writeUTF(fascia);
            dos.writeUTF(giorno);
            dos.close();
          }catch(IOException e){
                System.out.println("Errore salvataggio: "+e.toString());
                info.append("Salvataggio non riuscito\n");
          }
          info.append("Salvataggio terminato con successo\n");
     }


    public int fasciaToNum(String f){
	   if(f.equals("MATTINA")) return 0;
	   else if(f.equals("POMERIGGIO")) return 1;
       else if(f.equals("SERA")) return 2;
	   else if(f.equals("NOTTE")) return 3;
	   else return -1;

    }

    public int giornoToNum(String g){
	   if(g.equals("LUNEDI"))return 0;
	   else if(g.equals("MARTEDI"))return 1;
       else if(g.equals("MERCOLEDI"))return 2;
	   else if(g.equals("GIOVEDI"))return 3;
	   else if(g.equals("VENERDI"))return 4;
       else if(g.equals("SABATO"))return 5;
	   else if(g.equals("DOMENICA"))return 6;
	   else return -1;
    }


    public boolean libero(String g, String f){
       	if (matrice[fasciaToNum(f)][giornoToNum(g)]==1) return false;
	    else return true;
    }

    public void setMatrice(int matrix[][]){
        imgSettimana.setMatrice(matrix);
    }

    public void stampa(String s){
        info.append(s + "\n");
    }
	
	public void cancella(){
		info.setText("");
	}

    public Selezione getSelezione(){
         return new Selezione((String)selDay.getSelectedItem(),(String)selFascia.getSelectedItem());
    }


    public remoteAddr getServerAddr1(){
         return new remoteAddr(this.msgServer1.getText(), this.msgPort1.getText());		
	}

    public remoteAddr getServerAddr2(){
         return new remoteAddr(this.msgServer2.getText(), this.msgPort2.getText());
	}

    public void setReqInCorso(boolean reqInCorso){
	    this.reqInCorso=reqInCorso;
    }
		
	void buildConstraints(GridBagConstraints gbc,int gx,int gy,
								int gw,int gh,int wx,int wy){
			gbc.gridx=gx;
			gbc.gridy=gy;
			gbc.gridwidth=gw;
			gbc.gridheight=gh;
			gbc.weightx=wx;
			gbc.weighty=wy;
	}

    private JButton reqButton;
    private JButton aggButton;
    private JTextArea info;
    private JTextField msgServer1;
    private JTextField msgPort1;
    private JTextField msgServer2;
    private JTextField msgPort2;
    private JComboBox selDay;
    private JComboBox selFascia;
    private JComboBox selServer;
    private JScrollPane scrollPane;
    private JPanel reqPan;
    private Griglia imgSettimana;
    private TitledBorder titledBorder1;	
    private BorderLayout borderLayout1 = new BorderLayout();
    private Border border1;
    private Border border2;
    private TitledBorder titledBorder2;
    private Border border3;
    private Utente utente;
    int matrice[][] = new int[4][7];
    Selezione selCorrente;
    private JDialog finestraPassword;
    boolean reqInCorso;
    Client client = new Client(this);

}







