import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class FinReset extends JDialog implements ActionListener{
	JLabel labInfo1=new JLabel("Sei sicuro di ",JLabel.RIGHT);
	JLabel labInfo2=new JLabel("voler resettare?",JLabel.LEFT);
	JButton buttSi=new JButton("Si");
	JButton buttNo=new JButton("No");
	ServIODevice servDev;
	
	FinReset(JFrame superiore){
		super(superiore,"Sicurezza",true);
		
		servDev=(ServIODevice)superiore;
		getContentPane().setLayout(new GridLayout(2,2,10,10));
		getContentPane().setBackground(Color.gray);
		getContentPane().add(labInfo1);
		getContentPane().add(labInfo2);
		buttSi.addActionListener(this);
		getContentPane().add(buttSi);
		buttNo.addActionListener(this);
		getContentPane().add(buttNo);
	}
	
	
	public void actionPerformed(ActionEvent evt){
		Object source=evt.getSource();
		if (source==buttSi)
		{
			servDev.resetDb();
			servDev.server.notificaAltroServer("RESET");
		}
		if(source==buttNo)
			servDev.stampa("Annullato reset");
		hide();
	}
}			
