                             /*          InAscolto.java          */

import java.net.*;
import java.io.*;

public class InAscolto extends Thread{

   ServIODevice servDev;
   ServerSocket ascolto;
   String mode;
   int porta;

   public InAscolto(ServIODevice servDev, int porta, String mode){
     super("InAscolto");
     this.mode=mode;
     this.servDev=servDev;
	 this.porta=porta;
     try{
       ascolto = new ServerSocket(porta);
	   //debug
	   System.out.println("ascolto riuscita\n"+porta);
     }catch(IOException e){
       System.err.println("Impossibile creare socket: " + e.toString());
       System.exit(1);
     }
     if (mode.equals("CLI")) servDev.stampa("Server attivo...");
   }

   public void run(){
    Socket newSoc=null;
    while (true) {
     if (ascolto==null) return;
     try{
        newSoc=ascolto.accept();
     }catch(IOException e){
        System.err.println("Impossibile connettermi al socket client: "+e.toString());
        System.exit(1);
     }
     if (mode.equals("SER")){
       CoordinaServer coordServThr = new CoordinaServer(servDev, newSoc);
       coordServThr.start();
     }else if (mode.equals("CLI")){
       ServiClient servCliThr = new ServiClient(servDev, newSoc);
       servCliThr.start();
     }
    }
   }

}
