import java.net.*;
import java.io.*;


public class Notifica extends Thread{
    ServIODevice servDev;
    String mode,server2; 
	int port2;
	Socket soc;

    Notifica(ServIODevice servDev, String mode){
	  this.servDev=servDev;
      this.mode=mode;
    }
	
	public void run(){
      soc = null;
      server2 = servDev.getServer2();
      port2 = servDev.getPort2();
	  if (mode.equals("RESET")) notificaReset();
	  if (mode.equals("SAVE")) notificaSave();
	}
	
	public void notificaReset()
	{
      servDev.stampa("Notifica di reset al server " + server2);
      //richiesta di reset
      try{
       soc = new Socket(server2, port2);
       //invio richiesta 
       BufferedOutputStream bos = new BufferedOutputStream(soc.getOutputStream());
       DataOutputStream out = new DataOutputStream(bos);
       out.writeUTF(mode);                 //invio mode=RESET
       out.close();
       soc.close();
     }catch(IOException e){
         servDev.stampa("FALLITA NOTIFICA! Altro server down");
     }
	}
	
	public void notificaSave()
	{
      servDev.stampa("Notifica di salvataggio al server " + server2);
      //richiesta di reset
      try{
       soc = new Socket(server2, port2);
       //invio richiesta 
       BufferedOutputStream bos = new BufferedOutputStream(soc.getOutputStream());
       DataOutputStream out = new DataOutputStream(bos);
       out.writeUTF(mode);                 //invio mode=SAVE
       out.close();
       soc.close();
     }catch(IOException e){
         servDev.stampa("FALLITA NOTIFICA! Altro server down");
     }
	}
	
}

