                          /*    finConfigServer.java    */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;


public class finConfigServer extends JDialog implements ActionListener{

	private JPanel mainPan = new JPanel();
    private TitledBorder titledBorder2;
    private Border border3;
    private BorderLayout borderLayout1 = new BorderLayout();
	private JButton okButt = new JButton("OK");
	private JLabel labInfoAltroServ = new JLabel("Informazioni sull'altro Server");
	private JLabel labNome = new JLabel("Nome   ", JLabel.RIGHT);
	private JLabel labPorta = new JLabel("Porta   ", JLabel.RIGHT);
	private JLabel labInfoPorte = new JLabel("Porte per la comunicazione");
	private JLabel labPortClient = new JLabel("Porta per Client");
	private JLabel labPortServert = new JLabel("Porta per Server");
	private JTextField host = new JTextField("localhost");
	private JTextField port = new JTextField("3000");
	private JTextField portClient = new JTextField("4321");
	private JTextField portServer = new JTextField("2000");
	ServIODevice servDev;
	
	
	finConfigServer(JFrame superiore){
	   super(superiore,"Configura parametri",true);
	   
	   servDev=(ServIODevice)superiore;
       Container contentPane=(JPanel)getContentPane();
	   contentPane.setLayout(new BorderLayout());
	   contentPane.setBackground(Color.blue);
	   
       border3 = BorderFactory.createCompoundBorder(titledBorder2,
	                 BorderFactory.createEmptyBorder(5,5,5,5));
    
	   contentPane.setLayout(borderLayout1);
	   mainPan.setBorder(border3);
	   
       GridBagConstraints limiti = new GridBagConstraints();
       GridBagLayout gbl = new GridBagLayout();
       mainPan.setLayout(gbl);
	   
	   okButt.addActionListener(this);
	   
       buildConstraints(limiti,1,0,2,1,5,2);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       limiti.anchor=GridBagConstraints.SOUTH;
       gbl.setConstraints(labInfoAltroServ,limiti);
       mainPan.add(labInfoAltroServ);
	   
       buildConstraints(limiti,0,1,1,1,5,2);
       gbl.setConstraints(labNome,limiti);
       mainPan.add(labNome);
	   
       buildConstraints(limiti,1,1,1,1,3,2);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       gbl.setConstraints(host,limiti);
       mainPan.add(host);
	   
       buildConstraints(limiti,2,1,1,1,5,2);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       gbl.setConstraints(labPorta,limiti);
       mainPan.add(labPorta);
	   
       buildConstraints(limiti,3,1,1,1,9,2);
       gbl.setConstraints(port,limiti);
       mainPan.add(port);
	   
       buildConstraints(limiti,1,2,2,1,5,7);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       limiti.anchor=GridBagConstraints.SOUTH;
       gbl.setConstraints(labInfoPorte,limiti);
       mainPan.add(labInfoPorte);
	   
       buildConstraints(limiti,0,3,2,1,2,2);
       limiti.anchor=GridBagConstraints.EAST;
       gbl.setConstraints(labPortClient,limiti);
       mainPan.add(labPortClient);
	   
       buildConstraints(limiti,2,3,2,1,2,2);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       gbl.setConstraints(portClient,limiti);
       mainPan.add(portClient);
	   
       buildConstraints(limiti,0,4,2,1,2,2);
       limiti.anchor=GridBagConstraints.EAST;
       gbl.setConstraints(labPortServert,limiti);
       mainPan.add(labPortServert);
	   
       buildConstraints(limiti,2,4,2,1,2,2);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       gbl.setConstraints(portServer,limiti);
       mainPan.add(portServer);
	   
       buildConstraints(limiti,0,5,4,1,0,0);
       gbl.setConstraints(okButt,limiti);
       mainPan.add(okButt);
	   
	   this.setResizable(false);
       mainPan.setBackground(new Color(62, 97, 68));

       contentPane.add(mainPan);
	}


	public void actionPerformed(ActionEvent evt){
		if (evt.getSource() instanceof JButton){
			servDev.server2=host.getText().trim();
			servDev.porta2=Integer.parseInt(port.getText().trim());
			servDev.MyPortCli=Integer.parseInt(portClient.getText().trim());
			servDev.MyPortServ=Integer.parseInt(portServer.getText().trim());
			this.hide();
			setVisible(false);
			servDev.setTitle("Server: "+portClient.getText().trim());
			servDev.stampa("Altro Server: "+servDev.server2);
			servDev.stampa("       Porta: "+servDev.porta2);
			servDev.stampa("Porta per client: "+portClient.getText().trim());
			servDev.stampa("Porta per server: "+portServer.getText().trim());
		}
	}
    
	void buildConstraints(GridBagConstraints gbc,int gx,int gy,
								int gw,int gh,int wx,int wy){
			gbc.gridx=gx;
			gbc.gridy=gy;
			gbc.gridwidth=gw;
			gbc.gridheight=gh;
			gbc.weightx=wx;
			gbc.weighty=wy;  
	}



}